#ifndef BOOL
#define BOOL unsigned char
#endif
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

typedef struct tmp1 {
  char        *field;
  char        *dest;
  char        *information;
  struct tmp1 *next;
  struct tmp1 *prev;
} field_select_typ;

typedef struct tmp2 {
  BOOL convert;         /* Convert to mp3 */
  char *artist;         /* Artist of Song */
  char *title;          /* Title of Song  */
  char *album;          /* Albumname      */
  char *comment;        /* Comment        */
  int year;             /* year           */
  int genre;            /* mp3 - genre    */
  char *filename;       /* Filename       */
  char *dirname;        /* Dirname        */
  BOOL on_fly;          /* Convert on fly */
  char toc;             /* Tracknumber    */
  BOOL fn_auto;         /* generate fname */
  long int cddb_id;     /* ID of CDDB     */
  char *tmp_wav_file;   /* ripped wavefile*/
  long int frame_len;   /* length of file */
  struct tmp2 *next;    /* Pointer        */
  struct tmp2 *prev;
} song_typ;


#define PRG_VERSION VERSION

/* Default values */
#define MP3C_RCFILE     "mp3crc"
#define DEF_ETC_PATH    "/usr/local/etc"
#define TOT_GENRES      147
#define MP3C_BACKSPACE	''
#define MP3C_LOCKFILE   "~/.mp3c.lock"

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

/* Hmm, there seems to be two definitions ;-) */
#ifdef ENABLE_NLS
#ifndef HAVE_NLS
#define HAVE_NLS 1
#endif
#endif

#ifdef HAVE_NLS
#ifdef HAVE_LIBINTL_H
#include <libintl.h>
#endif
#ifdef HAVE_LOCALE_H
#include <locale.h>
#endif
#define _(str) gettext(str)
#else
#define _(str) str
#endif

